<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripResult_v2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripResult_v2 extends AbstractStructArrayBase
{
    /**
     * The TripResult_v2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripResult_v2[]
     */
    public $TripResult_v2;
    /**
     * Constructor method for ArrayOfTripResult_v2
     * @uses ArrayOfTripResult_v2::setTripResult_v2()
     * @param \StructType\TripResult_v2[] $tripResult_v2
     */
    public function __construct(array $tripResult_v2 = array())
    {
        $this
            ->setTripResult_v2($tripResult_v2);
    }
    /**
     * Get TripResult_v2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripResult_v2[]|null
     */
    public function getTripResult_v2()
    {
        return isset($this->TripResult_v2) ? $this->TripResult_v2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTripResult_v2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTripResult_v2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTripResult_v2ForArrayConstraintsFromSetTripResult_v2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTripResult_v2TripResult_v2Item) {
            // validation for constraint: itemType
            if (!$arrayOfTripResult_v2TripResult_v2Item instanceof \StructType\TripResult_v2) {
                $invalidValues[] = is_object($arrayOfTripResult_v2TripResult_v2Item) ? get_class($arrayOfTripResult_v2TripResult_v2Item) : sprintf('%s(%s)', gettype($arrayOfTripResult_v2TripResult_v2Item), var_export($arrayOfTripResult_v2TripResult_v2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TripResult_v2 property can only contain items of type \StructType\TripResult_v2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TripResult_v2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripResult_v2[] $tripResult_v2
     * @return \ArrayType\ArrayOfTripResult_v2
     */
    public function setTripResult_v2(array $tripResult_v2 = array())
    {
        // validation for constraint: array
        if ('' !== ($tripResult_v2ArrayErrorMessage = self::validateTripResult_v2ForArrayConstraintsFromSetTripResult_v2($tripResult_v2))) {
            throw new \InvalidArgumentException($tripResult_v2ArrayErrorMessage, __LINE__);
        }
        if (is_null($tripResult_v2) || (is_array($tripResult_v2) && empty($tripResult_v2))) {
            unset($this->TripResult_v2);
        } else {
            $this->TripResult_v2 = $tripResult_v2;
        }
        return $this;
    }
    /**
     * Add item to TripResult_v2 value
     * @throws \InvalidArgumentException
     * @param \StructType\TripResult_v2 $item
     * @return \ArrayType\ArrayOfTripResult_v2
     */
    public function addToTripResult_v2(\StructType\TripResult_v2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripResult_v2) {
            throw new \InvalidArgumentException(sprintf('The TripResult_v2 property can only contain items of type \StructType\TripResult_v2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TripResult_v2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripResult_v2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripResult_v2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripResult_v2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripResult_v2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripResult_v2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripResult_v2
     */
    public function getAttributeName()
    {
        return 'TripResult_v2';
    }
}
